<template>
  <div class="fullheight">
    <!-- <el-scrollbar class="editScroll">
      <div class="scroll_list"> -->
    <!-- 上 -->
    <div class="box-top">
      <!-- 左 -->
      <div class="chard1">
        <div class="title">全场寿命分布</div>
        <!-- <div class="box-card1">
          <el-form
            ref="form"
            :inline="true"
            :model="params"
            size="mini"
            style="padding-top:10px"
          >
            <el-form-item label="日期" label-width="85px">
              <el-date-picker
                v-model="params.collTime"
                type="date"
                value-format="yyyy-MM-dd"
                format="yyyy/MM/dd"
                placeholder="选择日期"
                style="width:150px"
              >
              </el-date-picker>
            </el-form-item>
          </el-form>
        </div> -->
        <div class="box-card1">
          <div class="content-title">全场风机寿命统计分布</div>
          <div class="content-card1">
            <div id="container1"></div>
          </div>
        </div>
      </div>
      <!-- 右 -->
      <div class="chard2">
        <div class="title">单机寿命</div>
        <div class="box-card2">
          <el-form
            ref="form"
            :inline="true"
            :model="params"
            size="mini"
            style="padding-top:10px;padding-left:10px;"
          >
            <el-form-item label="机组名称" label-width="60px">
              <el-select clearable v-model="params.fanCode" style="width:180px">
                <el-option
                  v-for="item in options"
                  :key="item.value"
                  :label="item.label"
                  :value="item.value"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-form>
          <div class="main-card2">
            <div class="content-title">1号机组整机寿命趋势图</div>
            <div class="content-card1">
              <div id="container2"></div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!-- 下 -->
    <div class="box-bottom">
      <div class="title">零部件寿命</div>
      <div class="box-card3">
        <div class="form">
          <div class="left-form">
            <el-form
              ref="form"
              :inline="true"
              :model="partsForm"
              label-width="70px"
              size="mini"
            >
              <el-form-item label="机组名称" label-width="60px">
                <el-select clearable v-model="value1" style="width:180px">
                  <el-option
                    v-for="item in options"
                    :key="item.value"
                    :label="item.label"
                    :value="item.value"
                  ></el-option>
                </el-select>
              </el-form-item>
              <el-form-item label="零部件">
                <el-select
                  clearable
                  v-model="partsForm.name"
                  style="width:180px"
                >
                  <el-option label="**1部件" value="1"></el-option>
                  <el-option label="**2部件" value="2"></el-option>
                </el-select>
              </el-form-item>
              <el-form-item>
                <el-button type="primary" icon="el-icon-search">查询</el-button>
              </el-form-item>
            </el-form>
          </div>
          <div class="working-box">
            <div class="icon_text">
              <i class="icon-fengsu1 icon_size"></i>
              <div class="text_data">
                <h3>风速</h3>
                <h3>10m/s</h3>
              </div>
            </div>
            <div class="icon_text">
              <i class="icon-fengxiang2 icon_size"></i>
              <div class="text_data">
                <h3>风向</h3>
                <h3>10°</h3>
              </div>
            </div>
            <div class="icon_text">
              <i class="el-icon-refresh icon_size"></i>
              <div class="text_data">
                <h3>转速</h3>
                <h3>2000rmp</h3>
              </div>
            </div>
            <div class="icon_text">
              <i class="icon-xuanzhuanjiaodu icon_size"></i>
              <div class="text_data">
                <h3>偏航角度</h3>
                <h3>10°</h3>
              </div>
            </div>
            <div class="icon_text">
              <i class="icon-fengdian3 icon_size"></i>
              <div class="text_data">
                <h3>变浆角度</h3>
                <h3>10°</h3>
              </div>
            </div>
          </div>
        </div>
        <div class="box-chard3">
          <el-card
            shadow="hover"
            body-style="padding:10px 20px;width:calc(100% - 40px);height:calc(100% - 20px)"
          >
            <div class="content-title" style="margin-bottom:10px">
              主轴瞬时载荷趋势
            </div>
            <div id="container3"></div>
          </el-card>

          <el-card
            shadow="hover"
            body-style="padding:20px 20px 10px;height:calc(100% - 30px);width:calc(100% - 40px)"
          >
            <div id="container4"></div>
          </el-card>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import req from '@/api/biz/statePrediction.js'
import prediction from '@/api/biz/healthData.js'
import {Chart} from '@antv/g2'
export default {
  name: 'life-prediction',
  data() {
    return {
      params: {
        collTime: '',
        fanCode: ''
      },
      dateTime: '',
      value1: '',
      options: [],
      partsForm: {
        name: '',
        model: ''
      },
      crewList: [], //剩余寿命列表
      pageBean: {
        page: 1,
        pageSize: -1
      },
      total: 0
    }
  },
  created() {
    this.getWindData()
    this.getDateTime()
  },
  mounted() {
    this.getCrewList()
    this.initChart3()
    this.initChart4()
    // 单机寿命
    this.initChart2()
  },
  methods: {
    // 获取当前日期
    getDateTime() {
      let yesterday = new Date().getTime() - 24 * 60 * 60 * 1000
      let date = new Date(yesterday)
      var year = date.getFullYear()
      var month = date.getMonth() + 1
      var day = date.getDate()
      if (month >= 1 && month <= 9) {
        month = '0' + month
      }
      if (day >= 0 && day <= 9) {
        day = '0' + day
      }
      this.dateTime = year + '-' + month + '-' + day
      this.params.collTime = this.dateTime
    },
    // 统计机组全场剩余寿命
    getCrewList() {
      // 选择日期则查询当天健康状态台数，否则不查询
      let dateTime = this.dateTime
      if (this.params.collTime) {
        dateTime = this.params.collTime
      }
      let data = {
        pageBean: this.pageBean,
        querys: [
          {
            group: 'main',
            operation: 'EQUAL',
            parentGroup: '',
            property: 'collTime',
            relation: 'AND',
            value: this.params.collTime
          }
        ]
      }
      prediction.getCrewList(data).then(res => {
        this.total = res.total
        this.crewList = res.rows
        this.initChart1()
      })
      // 全场寿命
    },
    initChart1() {
      const data = this.crewList
      const chart = new Chart({
        container: 'container1',
        autoFit: true,
        height: 500,
        forceFit: true
      })
      chart.data(data)
      chart.scale('residualLife', {
        nice: true,
        alias: '剩余寿命 %',
        max: 100,
        min: 0
      })
      chart.axis('residualLife', {
        label: {
          formatter: val => {
            return val + '%'
          }
        },
        grid: {
          line: {
            style: {
              stroke: '#586377',
              lineWidth: 1,
              lineDash: [3, 3]
            }
          }
        }
      })
      chart.option('scrollbar', {
        type: 'horizontal',
        categorySize: 40,
        animate: false,
        style: {
          thumbColor: '#199FD7', //滚动条背景颜色
          thumbHighlightColor: '#199FD7'
        }
      })
      chart.axis('fanCode', {
        line: {
          style: {
            lineWidth: 1,
            stroke: '#586377'
          }
        },
        label:{
          rotate:45,
          offset:20,
        }
      })
      chart.legend('fanCode', {
        maxItemWidth: 50,
        maxWidthRatio: 50
      })
      chart.tooltip({
        showTitle: true,
        showMarkers: false,
        domStyles: {
          'g2-tooltip': {
            background: 'rgba(0,0,0, 0.8)',
            color: '#d6e0ec'
          }
        }
      })
      chart.interaction('element-active')
      chart.interaction('active-region')

      chart
        .interval()
        .position('fanName*residualLife')
        .style({fill: 'l(90) 0:#22C3FE 0.5:#199FD7 1:#044879'})

      chart.render()
    },
    initChart2() {
      const data = [
        {month: '1', city: '寿命设计曲线', temperature: 1},
        {month: '1', city: '寿命预测曲线', temperature: 0.9},
        {month: '2', city: '寿命设计曲线', temperature: 0.8},
        {month: '2', city: '寿命预测曲线', temperature: 0.8},
        {month: '3', city: '寿命设计曲线', temperature: 0.7},
        {month: '3', city: '寿命预测曲线', temperature: 0.8},
        {month: '4', city: '寿命设计曲线', temperature: 0.8},
        {month: '4', city: '寿命预测曲线', temperature: 0.7},
        {month: '5', city: '寿命设计曲线', temperature: 0.7},
        {month: '5', city: '寿命预测曲线', temperature: 0.6},
        {month: '6', city: '寿命设计曲线', temperature: 0.5},
        {month: '6', city: '寿命预测曲线', temperature: 0.6},
        {month: '7', city: '寿命设计曲线', temperature: 0.5},
        {month: '7', city: '寿命预测曲线', temperature: 0.5},
        {month: '8', city: '寿命设计曲线', temperature: 0.4},
        {month: '8', city: '寿命预测曲线', temperature: 0.3},
        {month: '9', city: '寿命设计曲线', temperature: 0.3},
        {month: '9', city: '寿命预测曲线', temperature: 0.3},
        {month: '10', city: '寿命设计曲线', temperature: 0.2},
        {month: '10', city: '寿命预测曲线', temperature: 0.1},
        {month: '11', city: '寿命设计曲线', temperature: 0},
        {month: '11', city: '寿命预测曲线', temperature: 0}
      ]

      const chart = new Chart({
        container: 'container2',
        autoFit: true,
        height: 300
      })

      chart.data(data)
      chart.scale({
        month: {
          nice: true
        },

        temperature: {
          min: 0,
          tickCount: 5,
          tickInterval: 0.2,
          nice: true
        }
      })

      chart.tooltip({
        showCrosshairs: true,
        shared: true,
        domStyles: {
          'g2-tooltip': {
            background: 'rgba(0,0,0, 0.8)',
            color: '#d6e0ec'
          }
        }
      })
      chart.axis('month', {
        line: {
          style: {
            lineWidth: 1,
            stroke: '#586377'
          }
        }
      })
      chart.axis('temperature', {
        grid: {
          line: {
            style: {
              stroke: '#586377',
              lineWidth: 1,
              lineDash: [3, 3]
            }
          },
          alignTick: true
        }
      })
      chart.legend('city', {
        itemName: {
          style: {
            fill: '#979ba4'
          }
        }
      })
      chart
        .line()
        .position('month*temperature')
        .color('city')

      chart.render()
    },
    initChart3() {
      const data = [
        {month: '0', key: 'series1', value: 0},
        {month: '0', key: 'series2', value: 0.002},
        {month: '500', key: 'series1', value: 0.005},
        {month: '500', key: 'series2', value: 0.006},
        {month: '1000', key: 'series1', value: 0.01},
        {month: '1000', key: 'series2', value: 0.013},
        {month: '1500', key: 'series1', value: 0.015},
        {month: '1500', key: 'series2', value: 0.015},
        {month: '2000', key: 'series1', value: 0.02},
        {month: '2000', key: 'series2', value: 0.022},
        {month: '2500', key: 'series1', value: 0.025},
        {month: '2500', key: 'series2', value: 0.026},
        // {month: '3000', key: 'series1', value: 0.03},
        {month: '3000', key: 'series2', value: 0.031}
      ]

      const chart = new Chart({
        container: 'container3',
        autoFit: true,
        height: 300
      })

      chart.data(data)

      chart.scale('month', {
        range: [0, 1]
      })
      chart.scale({
        value: {
          min: 0,
          tickInterval: 0.005,
          nice: true
        }
      })
      // chart.scale('value', {
      //   nice: true
      // })
      chart.axis('value', {
        title: {
          text: '损伤',
          style: {
            fill: '#979ba4'
          }
        },
        line: {
          style: {
            lineWidth: 1,
            stroke: '#586377'
          }
        },
        grid: {
          line: {
            style: {
              stroke: '#586377',
              lineWidth: 1,
              lineDash: [3, 3]
            }
          },
          alignTick: true
        }
      })
      chart.axis('month', {
        // title: {
        //   text: '时间 Hours',
        //   style: {
        //     fill: '#979ba4'
        //   }
        // },
        line: {
          style: {
            lineWidth: 1,
            stroke: '#586377'
          }
        }
      })
      chart.legend('key', {
        itemName: {
          style: {
            fill: '#979ba4'
          }
        }
      })
      chart.tooltip({
        showCrosshairs: true,
        domStyles: {
          'g2-tooltip': {
            background: 'rgba(0,0,0, 0.8)',
            color: '#d6e0ec'
          }
        }
      })
      chart
        .line()
        .position('month*value')
        // .shape('hv')
        .color('key')
      chart.render()
    },
    initChart4() {
      const data = [
        {month: '1', city: '瞬时载荷', temperature: 7},
        {month: '1', city: '累计载荷', temperature: 3.9},
        {month: '3', city: '瞬时载荷', temperature: 150},
        {month: '3', city: '累计载荷', temperature: 1500},
        {month: '5', city: '瞬时载荷', temperature: 200},
        {month: '5', city: '累计载荷', temperature: 2000},
        {month: '7', city: '瞬时载荷', temperature: 800},
        {month: '7', city: '累计载荷', temperature: 3300},
        {month: '9', city: '瞬时载荷', temperature: 500},
        {month: '9', city: '累计载荷', temperature: 4100},
        {month: '11', city: '瞬时载荷', temperature: 200},
        {month: '11', city: '累计载荷', temperature: 5800},
        {month: '13', city: '瞬时载荷', temperature: 600},
        {month: '13', city: '累计载荷', temperature: 8000},
        {month: '15', city: '瞬时载荷', temperature: 300},
        {month: '15', city: '累计载荷', temperature: 11000},
        {month: '17', city: '瞬时载荷', temperature: 700},
        {month: '17', city: '累计载荷', temperature: 15000},
        {month: '19', city: '瞬时载荷', temperature: 500},
        {month: '19', city: '累计载荷', temperature: 18900}
      ]
      const chart = new Chart({
        container: 'container4',
        autoFit: true,
        height: 300
      })
      chart.data(data)
      chart.scale({
        month: {
          range: [0, 1]
        },
        temperature: {
          min: 0,
          tickInterval: 2000,
          nice: true
        }
      })
      chart.axis('month', {
        line: {
          style: {
            lineWidth: 1,
            stroke: '#586377'
          }
        }
      })
      chart.axis('temperature', {
        grid: {
          line: {
            style: {
              stroke: '#586377',
              lineWidth: 1,
              lineDash: [3, 3]
            }
          },
          alignTick: true
        }
      })
      chart.tooltip({
        showCrosshairs: true,
        shared: true,
        domStyles: {
          'g2-tooltip': {
            background: 'rgba(0,0,0, 0.8)',
            color: '#d6e0ec'
          }
        }
      })
      chart.legend('city', {
        itemName: {
          style: {
            fill: '#979ba4'
          }
        }
      })
      chart
        .line()
        .position('month*temperature')
        .color('city')
      chart.render()
    },
    getWindData() {
      let query = {
        sorter: [{direction: 'ASC', property: 'fanCode'}]
      }
      this.$http.post('${cssc}/biz/base/fanInfo/v1/list', query).then(resp => {
        let row = resp.data
        for (var i = 0; i < row.length; i++) {
          let obj = {}
          obj.label = row[i].fanName
          this.selecteCode = row[i].fanCode
          obj.value = row[i].fanCode
          this.options.push(obj)
        }
      })
    }
  }
}
</script>
<style lang="scss" scoped>
@import '@/assets/css/element-variables.scss';
.box-top {
  width: 100%;
  height: calc(45% - 10px);
  display: flex;
  justify-content: space-between;
}
.chard1 {
  width: calc(60%);
  margin-right: 10px;
}
.chard2 {
  width: 40%;
  height: 100%;
}
.box-bottom {
  width: 100%;
  height: 55%;
  margin-top: 10px;
}

.clearfix {
  text-align: center;
  span {
    font-size: 14px;
    color: $--color-text;
    font-weight: bold;
  }
}

.box-card {
  height: calc(100% - 52px);
}
#container1,
#container2,
#container3,
#container4 {
  height: 100%;
  width: 100%;
}

.title {
  height: 30px;
  width: calc(100% - 10px);
  line-height: 30px;
  font-size: 14px;
  padding-left: 10px;
  border-top-left-radius: 5px;
  border-top-right-radius: 5px;
  border-left: 1px solid #14867d;
  border-right: 1px solid #126d65;
  //  90deg, $--background-color-secondary-light,$--light-border
  background: -webkit-linear-gradient(
    to right,
    $--light-border,
    $--background-color-secondary-light
  );
  background: -o-linear-gradient(
    to right,
    $--light-border,
    $--background-color-secondary-light
  );
  background: -moz-linear-gradient(
    to right,
    $--light-border,
    $--background-color-secondary-light
  );
  background: linear-gradient(
    to right,
    $--light-border,
    $--background-color-secondary-light
  );
}
.box-card1,
.box-card2,
.box-card3 {
  width: 100%;
  height: calc(100% - 30px);
  border: 1px solid #14867d;
  border-top: 0;
  border-bottom-left-radius: 5px;
  border-bottom-right-radius: 5px;
  background-color: rgba(#134458, 0.3);
}

.card3 {
  height: 100%;
  background: none;
}
.content-title {
  height: 30px;
  width: 100%;
  text-align: center;
  line-height: 30px;
  color: $--color-text;
}
.content-card1 {
  width: calc(100% - 40px);
  height: calc(100% - 50px);
  padding: 10px 20px;
}
// .el-form {
//   padding-top: 10px;
// }
/deep/ .el-form-item__label,
/deep/ .el-input__inner {
  font-size: 12px;
}
.main-card2 {
  height: calc(100% - 40px);
}
.form {
  height: 65px;
  width: 100%;
  display: flex;
  align-items: center;
  div {
    height: 100%;
  }
  .left-form {
    flex: 0 0 55%;
  }
  .working-box {
    flex: 0 0 45%;
    background: rgba(#20baf3, 0.7);
    border-radius: 5px;
    text-align: center;
    display: flex;
    align-items: center;
    justify-content: space-around;
  }
}
.icon_text {
  flex: 0 0 18%;
  display: flex;
  align-items: center;
}
.text_data {
  flex: 0 0 60%;
  padding-top: 10px;
  h3 {
    font-size: 14px;
    margin: 5px 0;
  }
}

.box-card3 {
  padding: 10px;
  width: calc(100% - 20px);
  height: calc(100% - 50px);
}
.icon_size {
  flex: 0 0 40%;
  font-size: 36px;
  color: #03fae5;
}
.box-chard3 {
  padding-top: 10px;
  height: calc(100% - 65px);
  display: flex;
  justify-content: space-between;
  .el-card {
    width: calc(50% - 8px);
    margin-bottom: 10px;
  }
}
#container3 {
  height: calc(100% - 40px);
}
</style>
